from abc import abstractmethod
from logging import Logger
from typing import Any, Final, Iterator


class BaseSolver:
    def __init__(
        self, logger: Logger, verbose: bool, year: int, day: int, outputs: bool = False
    ):
        self.logger: Final = logger
        self.verbose: Final = verbose
        self.year: Final = year
        self.day: Final = day
        self.outputs = outputs

    @abstractmethod
    def solve(self, input: str) -> Iterator[Any]: ...
